Collection of test-cases for bugs in BWA.
To run, simply execute the "run.sh" script in the tests/bwa/.

Brief explanations are provided for each test-case in the corresponding README located in each folder.

Insertion changed to match, causing misalignment (commit: 607e11d43d840ec5abbbbcf685e8b469521b91a6)

Using revision 599e8407799ec603c3d36e9275cea959ede3a0bf (1 revision before 607e...):
$ bwa aln genome.fa read.fa | bwa samse genome.fa - read.fa  > good.sam
$ cat good.sam
@SQ	SN:Genome	LN:300
Sequence	16	Genome	36	37	1I3M1D37M1D146M	*	0	0	GCAGAATTGAAGCTGCTCCTTTGAATTTGCAATTCAATGTGAAATTCACCACGGGACTTGATAAGAAGAGGATTCCAACCCCTGTCTTTAGATTTACAGTCTAATGCTTACTCAGCCATCTTACCTATGTTCATCAACCGCTGACTATTTTCAACTAACCACAAAGACATCGGCACTCTGTACCTCC	*	XT:A:U	NM:i:3	X0:i:1	X1:i:0	XM:i:4	XO:i:1	XG:i:1	MD:Z:3^A37^A146


Using revision 607e11d43d840ec5abbbbcf685e8b469521b91a6:
$ bwa aln genome.fa read.fa | bwa samse genome.fa - read.fa  > bad.sam
$ cat bad.sam
@SQ	SN:Genome	LN:300
Sequence	16	Genome	36	37	1M3M1D37M1D146M	*	0	0	GCAGAATTGAAGCTGCTCCTTTGAATTTGCAATTCAATGTGAAATTCACCACGGGACTTGATAAGAAGAGGATTCCAACCCCTGTCTTTAGATTTACAGTCTAATGCTTACTCAGCCATCTTACCTATGTTCATCAACCGCTGACTATTTTCAACTAACCACAAAGACATCGGCACTCTGTACCTCC	*	XT:A:U	NM:i:138	X0:i:1	X1:i:0	XM:i:4	XO:i:1	XG:i:1	MD:Z:0C0A0G0A0^A1T1G0A1G0C0T0G0C0T0C1T2G0A1T2G0C0A1T1C0A1T0G0T0G0A0^A2T1C0A0C1A0C0G2A0C0T1G0A0T0A1G0A1G0A0G1A0T1C1A1C3T0G0T0C0T2A0G0A0T2A0C0A0G0T0C0T0A1T0G0C0T1A0C0T0C0A0G0C1A0T0C0T1A0C1T0A0T0G0T1C0A0T0C0A1C1G0C0T0G0A0C0T0A0T3C0A1C0T0A1C1A0C0A2G0A0C0A0T0C0G1C0A0C0T0C0T0G0T0A0C1T0C1T0

Phytophthora infestans T30-4 nuclear genome (Pi_nucl)
	http://protists.ensembl.org/Phytophthora_infestans/Info/Index
	ftp://ftp.ensemblgenomes.org/pub/protists/release-19/fasta/phytophthora_infestans/dna/Phytophthora_infestans.ASM14294v1.19.dna.toplevel.fa.gz

Phytophthora infestans Ia mitochondrial genome (Pi_mito)
	http://www.ncbi.nlm.nih.gov/nuccore/AY894835.1

args <- commandArgs(trailingOnly = TRUE)
if (length(args) != 3) {
    cat("Usage: plot_pca.R <input_prefix> <name_table> <output_file>\n",
        file=stderr())
    quit(status=1)
}


library(ggplot2)
library(ggrepel)


expanded.range <- function(values, expand.by=0.2)
{
    r <- range(values)
    p <- abs(r[2] - r[1]) * expand.by

    return(r + c(-0.5, 0.5) * p)
}


calc.lims <- function(x, y)
{
    x <- expanded.range(x)
    y <- expanded.range(y)
    xlen <- x[2] - x[1]
    ylen <- y[2] - y[1]

    if (xlen < ylen) {
        x <- x + c(-0.5, 0.5) * (ylen - xlen)
    }

    return(x)
}


plot.pca <- function(input_prefix, names.table=NULL)
{
    d <- read.table(paste(input_prefix, "evec", sep="."), as.is=TRUE)
    v <- read.table(paste(input_prefix, "eval", sep="."), as.is=TRUE)

    pc1 <- round(v$V1[1] / sum(v$V1), 3)
    pc2 <- round(v$V1[2] / sum(v$V1), 3)

    d$V1 <- sapply(strsplit(d$V1, ":", fixed=TRUE), function(x) x[1])
    d <- d[, 1:3]
    colnames(d) <- c("Name", "X", "Y")

    colors <- read.table(names.table, comment.char="", header=TRUE)
    final <- merge(d, colors)

    pp <- ggplot(final)
    pp <- pp + geom_text_repel(aes(x=X, y=Y, label=Name))

    pp <- pp + geom_point(aes(x=X, y=Y), color=final$Color, size=3)

    pp <- pp + xlab(sprintf("PC1: %.1f%%", pc1 * 100))
    pp <- pp + ylab(sprintf("PC2: %.1f%%", pc2 * 100))

    pp <- pp + theme_minimal()
    pp <- pp + xlim(calc.lims(final$X, final$Y))
    pp <- pp + ylim(calc.lims(final$Y, final$X))

    # Force 1:1 aspect ratio for the PCA plot; this must be done in
    # order to prevent misrepresenting distances on different axes.
    pp <- pp + coord_fixed()

    return(pp)
}


input_prefix <- args[1]
names_table <- args[2]
output_prefix <- args[3]

pdf(file=paste(output_prefix, ".pdf", sep=""))
plot.pca(input_prefix, names_table)
dev.off()

# bitmap is preferred, since it works in a headless environment
bitmap(paste(output_prefix, ".png", sep=""), height=6, width=6, res=96, taa=4, gaa=4)
plot.pca(input_prefix, names_table)
dev.off()

#!/usr/bin/env Rscript
# Copyright (c) 2013 Mikkel Schubert <MSchubert@snm.ku.dk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
require(ggplot2)
require(reshape2)


plot.admixture <- function(input_file, sample_names)
{
    samples <- read.table(sample_names, as.is=TRUE, comment.char="", header=TRUE)
    Q <- read.table(input_file)
    Q <- t(as.matrix(Q))
    colnames(Q) <- samples$Name

    # Order by name, and then move Sample to the right (Group is '-')
    Q <- Q[, order(samples$Group, samples$Name)]
    Q <- cbind(Q[, -1], Q[, 1, drop=FALSE])
    color <- samples$Color[order(samples$Group, samples$Name)]
    color <- c(color[-1], color[1])

    pp <- ggplot(melt(Q), aes(x=Var2, y=value, fill=Var1))
    pp <- pp + geom_bar(stat="identity")

    pp <- pp + xlab(NULL)
    pp <- pp + ylab("Ancestry")

    pp <- pp + theme_minimal()
    pp <- pp + theme(legend.position="None",
                     axis.text.y=element_blank(),
                     panel.grid.minor.y=element_blank(),
                     panel.grid.major.y=element_blank(),
                     axis.text.x=element_text(angle=25,
                                              hjust=1,
                                              size=12,
                                              color=color))

    return(pp)
}



args <- commandArgs(trailingOnly = TRUE)
if (length(args) != 3) {
    cat("Usage: admixture.R <input_file> <sample_names> <output_prefix>\n", file=stderr())
    quit(status=1)
}

input_file <- args[1]
sample_names <- args[2]
output_prefix <- args[3]

pdf(paste(output_prefix, ".pdf", sep=""))
plot.admixture(input_file, sample_names)
dev.off()

# bitmap is preferred, since it works in a headless environment
bitmap(paste(output_prefix, ".png", sep=""), height=5, width=5, res=96)
plot.admixture(input_file, sample_names)
dev.off()

#!/usr/bin/env Rscript
# Copyright (c) 2015 Mikkel Schubert <MSchubert@snm.ku.dk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

# Required for 'read.tree'
library(ape)
library(ggplot2)
library(grid)


TTBar <- setRefClass("TTBar",
            fields = list(leftmax = "numeric",
                          left = "numeric",
                          right = "numeric",
                          rightmax = "numeric"))


TTNode <- setRefClass("TTNode",
            fields = list(children = "list",
                          bar = 'TTBar',
                          len = "numeric",
                          label = "character",
                          group = "character"
                          ),
            methods = list(
                "initialize" = function(children = NULL, bar = NULL, len = 0,
                                        label = "", group = "") {
                    .self$children <- as.list(children)
                    if (!is.null(bar)) {
                        .self$bar <- bar
                    }
                    .self$len <- len
                    .self$label <- label
                    .self$group <- group
                },

                "show" = function() {
                    print(node$pformat())
                },

                "pformat" = function() {
                    return(paste(to_str(), ";", sep=""))
                },

                "to_str" = function() {
                    fields <- NULL
                    if (length(children)) {
                        child_str <- NULL
                        for (child in children) {
                            child_str <- c(child_str, child$to_str())
                        }

                        fields <- c(fields, "(", paste(child_str, sep="", collapse=","), ")")
                    }

                    if (nchar(label) > 0) {
                        fields <- c(fields, label)
                    }

                    if (length(len) > 0) {
                        fields <- c(fields, ":", len)
                    }

                    return(paste(fields, sep="", collapse=""))
                },

                "height_above" = function() {
                    total <- ifelse(length(children) > 0, 0, 1)
                    for (child in children_above()) {
                        total <- total + child$height_above() + child$height_below()
                    }

                    return(total)
                },

                "height_below" = function() {
                    total <- ifelse(length(children) > 0, 0, 1)
                    for (child in children_below()) {
                        total <- total + child$height_above() + child$height_below()
                    }

                    return(total)
                },

                "height" = function() {
                    return(height_above() + height_below())
                },

                "width" = function() {
                    total <- 0

                    for (child in children) {
                        total <- max(total, child$width())
                    }

                    if (length(len) > 0) {
                        total <- total + len
                    }

                    return(total)
                },

                "to_tables" = function(from_x=0, from_y=0) {
                    current_x <- from_x + ifelse(length(len) > 0, len, 0)

                    # Horizontal line
                    tables <- list(
                        labels=data.frame(
                            start_x=current_x,
                            start_y=from_y + calc_offset(from_y),
                            label=label,
                            group=get_labelgroup()
                        ),
                        segments=data.frame(
                            start_x=from_x,
                            start_y=from_y + calc_offset(from_y),
                            end_x=current_x,
                            end_y=from_y + calc_offset(from_y),
                            group=get_linegroup()),
                        bars=to_bar(current_x, from_y + calc_offset(from_y)))

                    max_y <- from_y
                    current_y <- max_y
                    for (child in children_above()) {
                        current_y <- current_y + child$height_below()
                        tables <- merge_tables(tables, child$to_tables(current_x, current_y))
                        max_y <- current_y + child$calc_offset(current_y)
                        current_y <- current_y + child$height_above()
                    }

                    min_y <- from_y
                    current_y <- min_y
                    for (child in children_below()) {
                        current_y <- current_y - child$height_above()
                        tables <- merge_tables(tables, child$to_tables(current_x, current_y))
                        min_y <- current_y + child$calc_offset(current_y)
                        current_y <- current_y - child$height_below()
                    }

                    # Vertical line
                    tables$segments <- rbind(tables$segments,
                        data.frame(
                            start_x=current_x,
                            start_y=max_y,
                            end_x=current_x,
                            end_y=min_y,
                            group=get_linegroup()))

                    return(tables)
                },

                "to_bar" = function(current_x, current_y) {
                    if (length(c(bar$leftmax, bar$left, bar$right, bar$rightmax)) != 4) {
                        return(data.frame())
                    }

                    return(data.frame(
                        start_x=c(bar$leftmax, bar$left, bar$right) + current_x,
                        end_x=c(bar$left, bar$right, bar$rightmax) + current_x,
                        start_y=current_y - c(0.25, 0.5, 0.25),
                        end_y=current_y + c(0.25, 0.5, 0.25)))
                },

                "merge_tables" = function(tbl_a, tbl_b) {
                    result <- list()
                    for (name in unique(names(tbl_a), names(tbl_b))) {
                        result[[name]] <- rbind(tbl_a[[name]], tbl_b[[name]])
                    }
                    return(result)
                },

                "clade" = function(taxa) {
                    # FIXME: Handle multiple tips with identical label
                    if (length(intersect(taxa, tips())) != length(taxa)) {
                        return(NULL)
                    }

                    for (child in children) {
                        if (length(intersect(taxa, child$tips())) == length(taxa)) {
                            return(child$clade(taxa))
                        }
                    }

                    return(.self)
                },

                "tips" = function(taxa) {
                    if (length(children) == 0) {
                        return(label)
                    } else {
                        result <- NULL
                        for (child in children) {
                            result <- c(result, child$tips())
                        }
                        return(result)
                    }
                },

                "calc_offset" = function(from_y) {
                    max_y <- from_y
                    current_y <- from_y
                    for (child in children_above()) {
                        current_y <- current_y + child$height_below()
                        max_y <- current_y + child$calc_offset(current_y)
                        current_y <- current_y + child$height_above()
                    }

                    min_y <- from_y
                    current_y <- from_y
                    for (child in children_below()) {
                        current_y <- current_y - child$height_above()
                        min_y <- current_y + child$calc_offset(current_y)
                        current_y <- current_y - child$height_below()
                    }

                    return(max_y - from_y - (max_y - min_y) / 2)
                },

                "children_above" = function() {
                    if (length(children) < 1) {
                        return(list())
                    }
                    return(children[1:ceiling(length(children) / 2)])
                },

                "children_below" = function() {
                    if (length(children) < 1) {
                        return(list())
                    }
                    return(children[(ceiling(length(children) / 2) + 1):length(children)])
                },

                "get_labelgroup" = function(prefix=NULL) {
                    if (is.null(prefix)) {
                        prefix <- ifelse(length(children) > 0, "node", "leaf")
                    }

                    if (nchar(group) > 0) {
                        prefix <- paste(prefix, ":", group, sep="")
                    }

                    return(prefix)
                },

                "get_linegroup" = function() {
                    prefix <- "line"
                    if (nchar(group) > 0) {
                        prefix <- paste(prefix, ":", group, sep="")
                    }

                    return(prefix)
                },

                "set_group" = function(value=NULL) {
                    .self$group <- ifelse(is.null(value), "line", value)
                    for (child in children) {
                        child$set_group(value)
                    }
                },

                "is_leaf" = function() {
                    '
                    Convinience function; returns true if the node is a leaf.
                    '
                    return(length(children) == 0)
                },

                "collect" = function() {
                    '
                    Returns a vector of all in the tree, including this node.
                    '
                    result <- .self
                    for (child in children) {
                        result <- c(result, child$collect())
                    }
                    return(result)
                },

                "sort_nodes" = function() {
                    if (!is_leaf()) {
                        widths <- NULL
                        for (child in children) {
                            widths <- c(widths, child$width())
                            child$sort_nodes()
                        }

                        .self$children <- children[order(widths, decreasing=FALSE)]
                    }
                }))


print.TTNode <- function(node)
{
    print(node$pformat())
}


tinytree.phylo.to.tt <- function(phylo)
{
    nnodes <- nrow(phylo$edge) + 1
    lengths <- phylo$edge.length
    to.node <- phylo$edge[, 2]
    from.node <- phylo$edge[, 1]

    nodes <- list()
    labels <- c(phylo$tip.label, phylo$node.label)
    for (edge in 1:nnodes) {
        len <- lengths[to.node == edge]
        nodes[[edge]] <- TTNode(label = labels[edge],
                                len = as.numeric(len))
    }

    for (edge in 1:nnodes) {
        from <- from.node[to.node == edge]
        if (length(from) != 0 && from != 0) {
            children <- nodes[[from]]$children
            children[[length(children) + 1]] <- nodes[[edge]]
            nodes[[from]]$children <- children
        }
    }

    root <- nodes[[length(phylo$tip.label) + 1]]
    root$len <- 0

    return(root)
}


tinytree.read.newick <- function(filename)
{
	return(tinytree.phylo.to.tt(read.tree(filename)))
}


tinytree.defaults.collect <- function(tt, defaults, values)
{
    stopifnot(!any(is.null(names(values))) || length(values) == 0)

    # Overwrite using user supplied values
    for (idx in seq(values)) {
        defaults[[names(values)[idx]]] <- values[[idx]]
    }

    # Set default values based on type (line, node, leaf, etc.)
    for (node in tt$collect()) {
        for (type in c(node$get_labelgroup(), node$get_linegroup())) {
            if (!(type %in% names(defaults))) {
                root <- unlist(strsplit(type, ":"))[[1]]
                stopifnot(root %in% names(defaults))
                defaults[[type]] <- defaults[[root]]
            }
        }
    }

    return(defaults)
}


tinytree.default.colours <- function(pp, tt, ...)
{
    defaults <- c("line"="black",
                  "node"="darkgrey",
                  "leaf"="black",
                  "bar"="blue")
    defaults <- tinytree.defaults.collect(tt, defaults, list(...))

    return(pp +
           scale_colour_manual(values=defaults) +
           scale_fill_manual(values=defaults))
}


tinytree.default.sizes <- function(pp, tt, ...)
{
    defaults <- c("line"=0.5,
                  "node"=4,
                  "leaf"=5)
    defaults <- tinytree.defaults.collect(tt, defaults, list(...))

    return(pp + scale_size_manual(values=defaults))
}


tinytree.draw <- function(tt, default.scales=TRUE, xaxis="scales", padding=0.3)
{
    tbl <- tt$to_tables(-tt$len)

    pp <- ggplot()
    pp <- pp + geom_segment(data=tbl$segments, lineend="round",
                            aes(x=start_x, y=start_y, xend=end_x, yend=end_y,
                                color=group, size=group))

    if (nrow(tbl$bars) > 0) {
        pp <- pp + geom_rect(data=tbl$bars, alpha=0.3,
                             aes(xmin=start_x, xmax=end_x, ymin=start_y, ymax=end_y,
                                 fill="bar"))
    }

    if (any(!is.na(tbl$labels$label))) {
        labels <- tbl$labels[!is.na(tbl$labels$label),]
        pp <- pp + geom_text(data=labels, hjust=0,
                             aes(label=sprintf(" %s", label),
                                 x=start_x, y=start_y, color=group, size=group))
    }

    pp <- pp + theme_minimal()

    # Disable legend
    pp <- pp + theme(legend.position="none",
    # Disable y axis + y axis labels + grid
                     axis.ticks.y=element_blank(),
                     axis.text.y=element_blank(),
                     panel.grid.minor.y=element_blank(),
                     panel.grid.major.y=element_blank(),
                     panel.grid.major  = element_line(colour = "grey90", size = 0.4),
                     panel.grid.minor  = element_line(colour = "grey90", size = 0.2))

    if (xaxis != "axis") {
        stopifnot(xaxis %in% c("scales", "none"))
        pp <- pp + theme(axis.ticks.x=element_blank(),
                         axis.text.x=element_blank(),
                         panel.grid.minor.x=element_blank(),
                         panel.grid.major.x=element_blank())

        if (xaxis == "scales") {
            y_offset <- min(tbl$segments$start_y, tbl$segments$end_y) - 3
            x_offset <- max(tbl$segments$end_x) * 0.2

            df <- data.frame(x=0, y=y_offset, xend=x_offset, yend=y_offset)
            pp <- pp + geom_segment(data=df,
                                    aes(color="line", size="line",
                                        x=x, xend=xend, y=y, yend=yend))

            df <- data.frame(x=x_offset, y=y_offset, label=paste("", signif(x_offset, 2)))
            pp <- pp + geom_text(data=df, aes(x=x, y=y, hjust=0, label=label,
                                              size="leaf", colour="leaf"))
        }
    }

    # Disable axis labels by default
    pp <- pp + xlab(NULL)
    pp <- pp + ylab(NULL)

    # Default colors; may be overwritten
    if (default.scales) {
        pp <- tinytree.default.sizes(pp, tt)
        pp <- tinytree.default.colours(pp, tt)
    }

    range <- max(tbl$segments$end_x) - min(tbl$segments$start_x)
    pp <- pp + coord_cartesian(xlim=c(min(tbl$segments$start_x),
                                      max(tbl$segments$end_x) + padding * range))

    return(pp)
}


plot.tree <- function(filename, sample_names, padding=0.3)
{
    samples <- read.table(sample_names, as.is=TRUE, comment.char="", header=TRUE)
    tt <- tinytree.read.newick(filename)
    tt$sort_nodes()

    for (node in tt$collect()) {
        if (node$is_leaf()) {
            node$set_group(node$label)
        }
    }

    pp <- tinytree.draw(tt,
                        default.scales=FALSE,
                        padding=padding)
    pp <- tinytree.default.sizes(pp, tt, "node"=3, "leaf"=4, "line"=0.75)

    defaults <- c("line"="black",
                  "node"="darkgrey",
                  "leaf"="black",
                  "bar"="blue")
    defaults <- tinytree.defaults.collect(tt, defaults, list())

    for (row in 1:nrow(samples)) {
        row <- samples[row, , drop=FALSE]
        key <- sprintf("leaf:%s", row$Name)
        print(c(key, row$Color))

        defaults[[key]] <- row$Color
    }
    print(defaults)

    return(pp +
           scale_colour_manual(values=defaults) +
           scale_fill_manual(values=defaults))
}


args <- commandArgs(trailingOnly = TRUE)
if (length(args) != 3) {
    cat("Usage: ggtinytree.R <input_file> <sample_names> <output_prefix>\n", file=stderr())
    quit(status=1)
}

input_file <- args[1]
sample_names <- args[2]
output_prefix <- args[3]

pdf(paste(output_prefix, ".pdf", sep=""))
plot.tree(input_file, sample_names)
dev.off()

# bitmap is preferred, since it works in a headless environment
bitmap(paste(output_prefix, ".png", sep=""), height=5, width=5, res=96)
plot.tree(input_file, sample_names)
dev.off()

#!/usr/bin/env Rscript
# Copyright (c) 2013 Mikkel Schubert <MikkelSch@gmail.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
args <- commandArgs(trailingOnly = TRUE)

if (length(args) != 2) {
    cat("Usage: test.R <table> <output_prefix>\n")
    quit(status=1)
}

library(ggplot2)


plot_coverage <- function(filename)
{
    tbl <- read.table(filename, as.is=TRUE, header=TRUE)
    tbl$Hits <- as.numeric(tbl$Hits)
    tbl$Size <- as.numeric(tbl$Size)
    tbl$Sample <- as.factor("Sample")

    # Correct size by number of uncalled ('N' / '-') bases
    tbl$RelHits <-  tbl$Hits / (tbl$Size - tbl$Ns)

    autosomes <- tbl[tbl$ID != 'X' & tbl$ID != 'Y',]
    autosomes$ID <- as.numeric(autosomes$ID)
    autosomes$NormHits <- 2 * autosomes$RelHits / mean(autosomes$RelHits)

    pp <- ggplot()

    pp <- pp + geom_hline(yintercept=range(autosomes$NormHits),
                          linetype='dashed', color="grey31")

    labels <- data.frame(x=max(autosomes$ID),
                         y=max(autosomes$NormHits) * 1.010,
                         label='Female')
    pp <- pp + geom_text(data=labels, aes(x=x, y=y, label=label),
                         vjust=0, hjust=1, color="grey31")

    pp <- pp + geom_hline(yintercept=0.5 * range(autosomes$NormHits),
                          linetype='dashed', color="grey")

    labels <- data.frame(x=max(autosomes$ID),
                         y=max(autosomes$NormHits) * 0.505,
                         label='Male?', color="grey")
    pp <- pp + geom_text(data=labels, aes(x=x, y=y, label=label),
                         vjust=0, hjust=1, color="grey")


    pp <- pp + geom_point(data=autosomes, aes(x=ID, y=NormHits))

    pp <- pp + ylab("Estimated ploidy")
    pp <- pp + xlab("Chromosome")
    pp <- pp + theme_bw()
    pp <- pp + theme(axis.ticks.x=element_blank(),
                     panel.border=element_blank())

    pp <- pp + scale_x_continuous(limits=range(autosomes$ID),
                                  breaks=seq(1, max(autosomes$ID) + 10, 10))


    sex <- tbl[tbl$ID == 'X' | tbl$ID == 'Y', , drop=FALSE]
    sex <- sex[order(sex$ID), , drop=FALSE]

    if (nrow(sex) > 0) {
        id_range <- range(autosomes$ID)
        step <- (id_range[2] - id_range[1]) / (nrow(sex) + 1)
        sex$x <- id_range[1] + step * 1:nrow(sex)

        sex$NormHits <- 2 * sex$RelHits / mean(autosomes$RelHits)

        pp <- pp + geom_point(data=sex, shape=sex$ID, color="red", size=5,
                          aes(x=x, y=NormHits))

        ymin <- min(0.500, 0.95 * min(autosomes$NormHits, sex$NormHits))
        ymax <- max(2.500, 1.05 * max(autosomes$NormHits, sex$NormHits))

        pp <- pp + scale_y_continuous(breaks=seq(1, 2),
                                      limits=c(ymin, ymax))
    }

    return(pp)
}


input_file <- args[1]
output_prefix <- args[2]

pdf(paste(output_prefix, ".pdf", sep=""), width=5, height=5)
plot_coverage(input_file)
dev.off()

# bitmap is preferred, since it works in a headless environment
bitmap(paste(output_prefix, ".png", sep=""), height=5, width=5, res=96, taa=4, gaa=4)
plot_coverage(input_file)
dev.off()

args <- commandArgs(trailingOnly = TRUE)
if (length(args) != 1) {
    cat("Usage: requires.R <module>\n")
    quit(status=1)
}

packages <- installed.packages()

for (module in args) {
    if (!(module %in% packages)) {
        cat(paste("R module '", module, "' is not installed!\n", sep=''))
        cat(paste("Please run R and execute the following command:\n\n"))
        cat(paste("> install.packages('", module, "')\n", sep=''))
        quit(status=1)
    }

    # Magic string to detect successful loading
    cat(paste("d0fd3ea6:", packageVersion(module), " \n"))

    quit(status=0)
}

#
# Copyright (C) 2011 by Joseph Pickrell
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

#
# functions for plotting a tree
#

library(RColorBrewer)
set_y_coords = function(d){
	i = which(d[,3]=="ROOT")
	y = d[i,8]/ (d[i,8]+d[i,10])
	d[i,]$y = 1-y
	d[i,]$ymin = 0
	d[i,]$ymax = 1
	c1 = d[i,7]
	c2 = d[i,9]
	ni = which(d[,1]==c1)
	ny = d[ni,8]/ (d[ni,8]+d[ni,10])
        d[ni,]$ymin = 1-y
	d[ni,]$ymax = 1
	d[ni,]$y = 1- ny*(y)

        ni = which(d[,1]==c2)
        ny = d[ni,8]/ (d[ni,8]+d[ni,10])
        d[ni,]$ymin = 0
        d[ni,]$ymax = 1-y
        d[ni,]$y = (1-y)-ny*(1-y)

	for (j in 1:nrow(d)){
		d = set_y_coord(d, j)
	}
	return(d)
}

set_y_coord = function(d, i){
	index = d[i,1]
	parent = d[i,6]
	if (!is.na(d[i,]$y)){
		return(d)
	}
	tmp = d[d[,1] == parent,]
	if ( is.na(tmp[1,]$y)){
		d = set_y_coord(d, which(d[,1]==parent))
		tmp = d[d[,1]== parent,]
	}
	py = tmp[1,]$y
	pymin = tmp[1,]$ymin
	pymax = tmp[1,]$ymax
	f = d[i,8]/( d[i,8]+d[i,10])
	#print (paste(i, index, py, pymin, pymax, f))
	if (tmp[1,7] == index){
		d[i,]$ymin = py
		d[i,]$ymax = pymax
		d[i,]$y = pymax-f*(pymax-py)
		if (d[i,5]== "TIP"){
			d[i,]$y = (py+pymax)/2
		}
	}
	else{
		d[i,]$ymin = pymin
		d[i,]$ymax = py
		d[i,]$y = py-f*(py-pymin)
                if (d[i,5]== "TIP"){
                        d[i,]$y = (pymin+py)/2
                }

	}
	return(d)
}


set_x_coords = function(d, e){
	i = which(d[,3]=="ROOT")
	index = d[i,1]
        d[i,]$x = 0
        c1 = d[i,7]
        c2 = d[i,9]
        ni = which(d[,1]==c1)
	tmpx =  e[e[,1]==index & e[,2] == c1,3]
	if (length(tmpx) == 0){
		tmp = e[e[,1] == index,]
		tmpc1 = tmp[1,2]
		if ( d[d[,1]==tmpc1,4] != "MIG"){
			tmpc1 = tmp[2,2]
		}
		tmpx = get_dist_to_nmig(d, e, index, tmpc1)
	}
	if(tmpx < 0){
		tmpx = 0
	}
        d[ni,]$x = tmpx

        ni = which(d[,1]==c2)
        tmpx =  e[e[,1]==index & e[,2] == c2,3]
	if (length(tmpx) == 0){
    		tmp = e[e[,1] == index,]
                tmpc2 = tmp[2,2]
                if ( d[d[,1]==tmpc2,4] != "MIG"){
                        tmpc2 = tmp[1,2]
                }
                tmpx = get_dist_to_nmig(d, e, index, tmpc2)
	}
        if(tmpx < 0){
                tmpx = 0
        }
        d[ni,]$x = tmpx

        for (j in 1:nrow(d)){
                d = set_x_coord(d, e, j)
        }
        return(d)
}


set_x_coord = function(d, e, i){
	index = d[i,1]
        parent = d[i,6]
        if (!is.na(d[i,]$x)){
                return(d)
        }
        tmp = d[d[,1] == parent,]
        if ( is.na(tmp[1,]$x)){
                d = set_x_coord(d, e, which(d[,1]==parent))
                tmp = d[d[,1]== parent,]
        }
	#print (paste(parent, index))
	tmpx =  e[e[,1]==parent & e[,2] == index,3]
	if (length(tmpx) == 0){
                tmp2 = e[e[,1] == parent,]
                tmpc2 = tmp2[2,2]
		#print
                if ( d[d[,1]==tmpc2,4] != "MIG"){
                        tmpc2 = tmp2[1,2]
                }
		tmpx = get_dist_to_nmig(d, e, parent, tmpc2)
	}
        if(tmpx < 0){
                tmpx = 0
        }
	d[i,]$x = tmp[1,]$x+ tmpx
	return(d)
}

plot_tree_internal = function(d, e, samples, o = NA, cex = 1, disp = 0.005, plus = 0.005, arrow = 0.05, ybar = 0.01, scale = T, mbar = T, mse = 0.01, plotmig = T, plotnames = T, xmin = 0, lwd = 1, font = 1){
	plot(d$x, d$y, axes = F, ylab = "", xlab = "Drift parameter", xlim = c(xmin, max(d$x)+plus), pch = "")
	axis(1)
	mw = max(e[e[,5]=="MIG",4])
	mcols = rev(heat.colors(150))
	for(i in 1:nrow(e)){
		col = "black"
		if (e[i,5] == "MIG"){
			w = floor(e[i,4]*200)+50
			if (mw > 0.5){
				w = floor(e[i,4]*100)+50
			}
			col = mcols[w]
			if (is.na(col)){
				col = "blue"
			}
		}
		v1 = d[d[,1] == e[i,1],]
		v2 = d[d[,1] == e[i,2],]
		if (e[i,5] == "MIG"){
			if (plotmig){
			arrows( v1[1,]$x, v1[1,]$y, v2[1,]$x, v2[1,]$y, col = col, length = arrow)
			}
		}
		else{
			lines( c(v1[1,]$x, v2[1,]$x), c(v1[1,]$y, v2[1,]$y), col = col, lwd = lwd)
		}
	}
	tmp = d[d[,5] == "TIP",]
	if ( !is.na(o)){
		for(i in 1:nrow(tmp)){
			tcol = o[o[,1] == tmp[i,2],2]
			if(plotnames){
				#print(tmp[i,2])
				text(tmp[i,]$x+disp, tmp[i,]$y, labels = tmp[i,2], adj = 0, cex = cex, col  = tcol, font = font)
			}
		}
	}
	else{
		if (plotnames){
          cols = NULL
          for (name in tmp[, 2]) {
            if (name %in% samples$Name) {
                cols <- append(cols, head(samples$Color[samples$Name == name], 1))
            } else {
                cols <- append(cols, "#000000")
            }
          }

		  text(tmp$x+disp, tmp$y, labels = tmp[,2], adj = 0, cex = cex, font = font, col=cols)
		}
	}
	if (scale){
	print (paste("mse", mse))
        lines(c(0, mse*10), c(ybar, ybar))
	text( 0, ybar - 0.04, lab = "10 s.e.", adj = 0, cex  = 0.8)
	lines( c(0, 0), c( ybar - 0.01, ybar+0.01))
	lines( c(mse*10, mse*10), c(ybar- 0.01, ybar+ 0.01))
	}
        if (mbar){
                mcols = rev( heat.colors(150) )
                mcols = mcols[50:length(mcols)]
                ymi = ybar+0.15
                yma = ybar+0.35
                l = 0.2
                w = l/100
                xma = max(d$x/20)
                rect( rep(0, 100), ymi+(0:99)*w, rep(xma, 100), ymi+(1:100)*w, col = mcols, border = mcols)
                text(xma+disp, ymi, lab = "0", adj = 0, cex = 0.7)
		if ( mw >0.5){ text(xma+disp, yma, lab = "1", adj = 0, cex = 0.7)}
                else{
			text(xma+disp, yma, lab = "0.5", adj = 0, cex =0.7)
		}
		text(0, yma+0.06, lab = "Migration", adj = 0 , cex = 0.6)
		text(0, yma+0.03, lab = "weight", adj = 0 , cex = 0.6)
        }
}

set_mig_coords = function(d, e){
	for (j in 1:nrow(d)){
		if (d[j,4] == "MIG"){
			p = d[d[,1] == d[j,6],]
			c = d[d[,1] == d[j,7],]
			tmpe = e[e[,1] == d[j,1],]
			y1 = p[1,]$y
			y2 = c[1,]$y
			x1 = p[1,]$x
			x2 = c[1,]$x

			mf = tmpe[1,6]
			if (is.nan(mf)){
				mf = 0
			}
			#d[j,]$y = (y1+y2)* mf
                        #d[j,]$x = (x1+x2) *mf
                        d[j,]$y = y1+(y2-y1)* mf
			print(paste(mf, x1, x2))
                        d[j,]$x = x1+(x2-x1) *mf
		}

	}
	return(d)

}

get_f = function(stem){
	d = paste(stem, ".cov.gz", sep = "")
	d2 = paste(stem, ".modelcov.gz", sep = "")
	d = read.table(gzfile(d), as.is = T, comment.char = "", quote = "")
	d2 = read.table(gzfile(d2), as.is = T, comment.char = "", quote = "")
	d = d[order(names(d)), order(names(d))]
	d2 = d2[order(names(d2)), order(names(d2))]
	tmpcf = vector()
        tmpmcf = vector()
        for (j in 1:nrow(d)){
                for (k in (j+1):nrow(d)){
                        tmpcf = append(tmpcf, d[j,k])
                        tmpmcf = append(tmpmcf, d[j,k] - d2[j,k])
                }
        }
        tmpv = var(tmpmcf)/var(tmpcf)
	return(1-tmpv)

}

plot_tree = function(stem, samples, o = NA, cex = 1, disp = 0.003, plus = 0.01, flip = vector(), arrow = 0.05, scale = T, ybar = 0.1, mbar = T, plotmig = T, plotnames = T, xmin = 0, lwd = 1, font = 1){
    samples = read.table(samples, as.is=T, header=T, comment.char="")
	d = paste(stem, ".vertices.gz", sep = "")
	e = paste(stem, ".edges.gz", sep = "")
	se = paste(stem, ".covse.gz", sep = "")
	d = read.table(gzfile(d), as.is = T, comment.char = "", quote = "")
	e = read.table(gzfile(e), as.is  = T, comment.char = "", quote = "")
	if (!is.na(o)){
		o = read.table(o, as.is = T, comment.char = "", quote = "")
	}
	e[,3] = e[,3]*e[,4]
	e[,3] = e[,3]*e[,4]

	se = read.table(gzfile(se), as.is = T, comment.char = "", quote = "")
	m1 = apply(se, 1, mean)
	m = mean(m1)
	#m = 0
	for(i in 1:length(flip)){
		d = flip_node(d, flip[i])
	}
	d$x = "NA"
	d$y = "NA"
	d$ymin = "NA"
	d$ymax = "NA"
	d$x = as.numeric(d$x)
	d$y = as.numeric(d$y)
	d$ymin = as.numeric(d$ymin)
	d$ymax = as.numeric(d$ymax)

	d = set_y_coords(d)
	d = set_x_coords(d, e)
	d = set_mig_coords(d, e)
	plot_tree_internal(d, e, samples, o = o, cex = cex, xmin = xmin, disp = disp, plus = plus, arrow = arrow, ybar = ybar, mbar = mbar, mse = m, scale = scale, plotmig = plotmig, plotnames = plotnames, lwd = lwd, font = font)
	return(list( d= d, e = e))
}

get_dist_to_nmig = function(d, e, n1, n2){
	toreturn = e[e[,1] == n1 & e[,2] == n2,3]
	#print(toreturn)
	while ( d[d[,1] ==n2,4] == "MIG"){
		tmp = e[e[,1] == n2 & e[,5] == "NOT_MIG",]
		toreturn = toreturn+tmp[1,3]
		n2 = tmp[1,2]
	}
	return(toreturn)
}

flip_node = function(d, n){
	i = which(d[,1] == n)
	t1 = d[i,7]
	t2 = d[i,8]
	d[i,7] = d[i,9]
	d[i,8] = d[i,10]
	d[i,9] = t1
	d[i,10] = t2
	return(d)

}

plot_modelcov = function(stem, pop_order, min = -0.009, max = 0.009, cex = 1, usemax = T){
        c = read.table(gzfile(paste(stem, ".modelcov.gz", sep = "")), as.is = T, head = T)
        o = read.table(pop_order, as.is = T, comment.char = "", quote = "")


        toplot = data.frame(matrix(nrow = nrow(c), ncol = ncol(c)))
        for(i in 1:nrow(o)){
                for( j in 1:nrow(o)){

                        toplot[i, j] = c[which(names(c)==o[i,1]), which(names(c)==o[j,1])]
                }
        }
        if (usemax){
                m1 = max(abs(toplot))
                max = m1*1.1
                min = -(m1*1.1)
        }
        names(toplot) = o[,1]
        plot_resid_internal(toplot, max = max, min = min)
}



plot_cov = function(stem, pop_order, min = -0.009, max = 0.009, cex = 1, usemax = T, wcols = ""){
        c = read.table(gzfile(paste(stem, ".cov.gz", sep = "")), as.is = T, head = T)
        o = read.table(pop_order, as.is = T)


        toplot = data.frame(matrix(nrow = nrow(c), ncol = ncol(c)))
        for(i in 1:nrow(o)){
                for( j in 1:nrow(o)){

                        toplot[i, j] = c[which(names(c)==o[i,1]), which(names(c)==o[j,1])]
                }
        }
        if (usemax){
                m1 = max(abs(toplot))
                max = m1*1.1
                min = 0
        }
        names(toplot) = o[,1]
        plot_cov_internal(toplot, max = max, min = min, wcols = wcols, o = o, cex = cex)
}


plot_resid = function(stem, pop_order, min = -0.009, max = 0.009, cex = 1, usemax = T, wcols = "r"){
	c = read.table(gzfile(paste(stem, ".cov.gz", sep = "")), as.is = T, head = T, quote = "", comment.char = "")
	m = read.table(gzfile(paste(stem, ".modelcov.gz", sep = "")), as.is = T, head = T, quote = "", comment.char = "")
	names(c) = rownames(c)
	names(m) = rownames(m)
	o = read.table(pop_order, as.is = T, comment.char = "", quote = "", header = TRUE)
	se = read.table(gzfile(paste(stem, ".covse.gz", sep = "")), as.is = T, head = T, quote = "", comment.char = "")
	mse = apply(se, 1, mean)
	mse = mean(mse)
	c = c[order(names(c)), order(names(c))]
	m = m[order(names(m)), order(names(m))]
	tmp = c -m
	#tmp = m - c
	#tmp = (m-c)/m
	#print(tmp)
	toplot = data.frame(matrix(nrow = nrow(tmp), ncol = ncol(tmp)))
	for(i in 1:nrow(o)){
	        for( j in 1:nrow(o)){
			#print(paste(o[i,1], o[j,1]))
			if (o[i,1] %in% names(tmp) ==F){
				print(paste("not found", o[i,1]))
			}
			if (o[j,1] %in% names(tmp) ==F){
				print(paste("not found", o[j,1]))
			}
        	        toplot[i, j] = tmp[which(names(tmp)==o[i,1]), which(names(tmp)==o[j,1])]
        	}
	}
	#print(toplot)
	if (usemax){
		m1 = max(abs(toplot), na.rm = T)
		max = m1*1.02
		min = -(m1*1.02)
	}
	names(toplot) = o[,1]
	toreturn = plot_resid_internal(toplot, max = max, min = min, wcols = wcols, mse = mse, o = o, cex = cex)
	return(toreturn)
}

plot_cov_internal = function(d, o = NA, max = 0.009, min = -0.009, cex =0.5, wcols = "", mse = 5){
        npop = nrow(d)
        width = 1/npop
        height = 1/npop
        colors = brewer.pal(9, "Spectral")
        colors = c("red", "orange","yellow", "white", "green", "blue", "black")
        pal = colorRampPalette(colors)
        ncol = 80
        cols = pal(ncol)
        plot("NA", xlim = c(0, 1), ylim = c(0, 1), axes = F, xlab = "", ylab = "")
        for (i in 1:npop){
                for( j in 1:i){
                        v = d[i,j]
                        col= "white"
                        if (v < 0){
                                if (wcols == "rb"){
                                col = rgb(0, 0, 1, v/min)
                                }
                                else{
                                #col = rgb(0, 0, 1, 0.1+0.9*(v/min))
                                col = cols[ncol/2-floor( (v/min)*(ncol/2))]
                                }
                        }
                        else{
                                if (wcols == "rb"){
                                col = rgb(1, 0, 0, v/max)
                                }
                                else{
                                #col = rgb(1, 0, 0, 0.1+0.9*(v/max))
                                col = cols[ceiling((v/max)*(ncol))]
                                }
                        }
                        xmin = j/npop - 1/npop
                        xmax = j/npop
                        ymin = 1-(i/npop)
                        ymax = 1-(i/npop)+1/npop
			if (v == 0){ col = "white"}
                        rect(xmin, ymin, xmax, ymax, col = col, border = col)
                }
                tcol = "black"
                tmp = o[o[,1] == names(d)[i],]
                if (length(tmp) != 1){
                        tcol = tmp[1,2]
                }
                mtext(names(d)[i], side = 2, at = 1-i/npop+0.5/npop, las = 1, cex = cex, col = tcol)
                mtext(names(d)[i], side = 1, at =  i/npop-0.5/npop, las = 3, cex = cex, col = tcol)
        }
        if ( !is.na(mse)){
                ymi = 0.5
                yma = 0.9
                w = (yma-ymi)/ncol
                xma = 0.80
                lmi = round(min, digits = 1)
                lma = round(max, digits = 1)
                print(cols)
                print(ymi+(0:ncol)*w)
                rect( rep(0.75, ncol), ymi+(0:(ncol-1))*w, rep(xma, ncol), ymi+(1:ncol)*w, col = cols, border = cols)
                text(xma+0.01, ymi, lab = paste(lmi),  adj = 0, cex = 0.8)
                text(xma+0.01, yma, lab = paste(lma, "(Variance)"), adj = 0, cex = 0.8)

        }
        return(d)
        #image(as.matrix(d), col = cols)
}

plot_resid_internal = function(d, o = NA, max = 0.009, min = -0.009, cex =0.5, wcols = "rb", mse = NA){
        npop = nrow(d)
        width = 1/npop
        height = 1/npop
	colors = brewer.pal(9, "Spectral")
	colors = c("red", "orange","yellow", "white", "green", "blue", "black")
	pal = colorRampPalette(colors)
	ncol = 80
	cols = pal(ncol)
        plot("NA", xlim = c(0, 1), ylim = c(0, 1), axes = F, xlab = "", ylab = "")
        for (i in 1:npop){
                for( j in 1:i){
                        v = d[i,j]
			print(paste(i, j, v))
                        col= "white"
                        if (v < 0){
				if (wcols == "rb"){
				col = rgb(0, 0, 1, v/min)
				}
				else{
                                #col = rgb(0, 0, 1, 0.1+0.9*(v/min))
				col = cols[ncol/2-floor( (v/min)*(ncol/2))]
				#col = "white"
				}
                        }
                        else{
				if (wcols == "rb"){
				col = rgb(1, 0, 0, v/max)
				}
				else{
                                #col = rgb(1, 0, 0, 0.1+0.9*(v/max))
				col = cols[ncol/2+ceiling((v/max)*(ncol/2))]
				}
                        }
                        xmin = j/npop - 1/npop
                        xmax = j/npop
                        ymin = 1-(i/npop)
                        ymax = 1-(i/npop)+1/npop
                        rect(xmin, ymin, xmax, ymax, col = col, border = col)
                }
		tcol = "black"
		tmp = o[o[,1] == names(d)[i],]
		if (length(tmp) != 1){
			tcol = tmp[1, "Color"]
		}
                mtext(names(d)[i], side = 2, at = 1-i/npop+0.5/npop, las = 1, cex = cex, col = tcol)
                mtext(names(d)[i], side = 1, at =  i/npop-0.5/npop, las = 3, cex = cex, col = tcol)
        }
	if ( !is.na(mse)){
                ymi = 0.5
                yma = 0.9
                w = (yma-ymi)/ncol
                xma = 0.80
		lmi = round(min/mse, digits = 1)
		lma = round(max/mse, digits = 1)
		print(cols)
		print(ymi+(0:ncol)*w)
                rect( rep(0.75, ncol), ymi+(0:(ncol-1))*w, rep(xma, ncol), ymi+(1:ncol)*w, col = cols, border = cols)
                text(xma+0.01, ymi, lab = paste(lmi, "SE"),  adj = 0, cex = 0.8)
                text(xma+0.01, yma, lab = paste(lma, "SE"), adj = 0, cex = 0.8)

	}
	return(d)
	#image(as.matrix(d), col = cols)
}


check_cov <- function(stem)
{
    cov <- read.table(gzfile(paste(stem, ".cov.gz", sep = "")),
                      as.is=TRUE, head=TRUE)

    if (any(is.nan(as.matrix(cov)))) {
        plot(NA, NA,
             bty="n",
             xaxt="n",
             yaxt="n",
             type="n",
             xlab=NA,
             ylab=NA,
             title=NULL,
             xlim=c(0, 1),
             ylim=c(0, 1))

        text(x=0.5, y=0.5, adj=c(0.5, 0.5), cex=5.0,
             labels="Insufficient data\nto run TreeMix!",)

        return(FALSE)
    } else {
        return(TRUE)
    }
}




args <- commandArgs(trailingOnly = TRUE)
if (length(args) < 1) {
    cat("Usage: treemix.R <func> [...]\n", file=stderr())
    quit(status=1)
}

func_name <- args[1]
if (func_name == "plot_tree") {
    if (length(args) != 4) {
        cat("Usage: plotting_funcs.R plot_tree <input_file> <names_file> <output_prefix>\n", file=stderr())
        quit(status=1)
    }

    input_file <- args[2]
    names_file <- args[3]
    output_prefix <- args[4]

    pdf(paste(output_prefix, ".pdf", sep=""))
    if (check_cov(input_file)) {
        plot_tree(input_file, names_file)
    }
    dev.off()

    # bitmap is preferred, since it works in a headless environment
    bitmap(paste(output_prefix, ".png", sep=""), height=6, width=6, res=96, taa=4, gaa=4)
    if (check_cov(input_file)) {
        plot_tree(input_file, names_file)
    }
    dev.off()
} else if (func_name == "plot_residuals") {
    if (length(args) != 4) {
        cat("Usage: plotting_funcs.R plot_residuals <input_file> <names_file> <output_prefix>\n", file=stderr())
        quit(status=1)
    }

    input_file <- args[2]
    names_file <- args[3]
    output_prefix <- args[4]

    pdf(paste(output_prefix, ".pdf", sep=""))
    if (check_cov(input_file)) {
        plot_resid(input_file, names_file)
    }
    dev.off()

    # bitmap is preferred, since it works in a headless environment
    bitmap(paste(output_prefix, ".png", sep=""), height=6, width=6, res=96, taa=4, gaa=4)
    if (check_cov(input_file)) {
       plot_resid(input_file, names_file)
    }
    dev.off()
} else if (func_name == "variance") {
    if (length(args) != 3) {
        cat("Usage: plotting_funcs.R variance <input_prefix> <output_file>\n", file=stderr())
        quit(status=1)
    }

    input_prefix <- args[2]
    output_file <- args[3]

    cat(sprintf("%f\n", get_f(input_prefix)), file=output_file)
} else {
    cat("Unknown function: ", func_name, "\n", file=stderr())
    quit(status=1)
}

############################################################
## Part 46:
input <- read.csv("Potato_merged.csv", header=TRUE, row.names=1, sep="\t")

dim(input)

abundances <- input[row.names(input)[grep("g__[\\w_]*$", row.names(input), perl=TRUE)],]
row.names(abundances) <- sapply(strsplit(row.names(abundances), "g__"), `[`, 2)
write.csv(abundances, "Relative_abundances_genus.csv")


############################################################
## Part 47:

# Load required packages
library(permute)
library(vegan)
library(MASS)
# Calculate the number of genera identified for each profile
taxon_table <- specnumber(t(abundances))
# Export a summary table
write.table(taxon_table, "Taxon_count_genus.txt", sep="\t", col.names=FALSE)
# Calculate the Shannon diversity index for each profile at the genus level
diversity_table <- diversity(t(abundances), index="shannon")
# Export a summary table
write.table(diversity_table, "Diversity_genus.txt", sep="\t", col.names=FALSE)
# Calculate Bray-Curtis distances among profiles at the genus level
distances <- vegdist(t(abundances), method="bray")
# Export a summary table
write.matrix(as.matrix(distances), "Distances_genus.txt", sep="\t")


############################################################
## Part 48:

# Load required packages
library(gplots)
# Save heatmap as .pdf file
pdf("Heatmap_genus.pdf")
# Draw the heatmap (see below)
heatmap.2(as.matrix(abundances), trace="none", col=colorpanel(50, low="gray91", mid="darkblue", high="red"), dendrogram="both", ColSideColors=rep(c("red","green","blue"), times=c(5,1,3)), margins=c(12, 13))
# Close the .pdf file
dev.off()


############################################################
## Part 49:

# Perform the Principal Coordinate Analysis
library(ape)
pcoa <- pcoa(distances)
# Save the PCA plot as a pdf file.
pdf("PCOA_genus.pdf")


############################################################
## Part 50:

# Plot the first two dimensions
plot(pcoa$vectors[,1], pcoa$vectors[,2], pch=16, cex=1.5, cex.axis=0.9, font.lab=2, font.axis=2, xlab="Dimension 1", ylab="Dimension 2", col=rep(c("red","green","blue"), times=c(5, 1, 3)))
# Add profile name labels, colored using the same color scheme as above.
text(x=pcoa$vectors[,1], y=pcoa$vectors[,2], labels=row.names(pcoa$vectors), font=2, cex=0.8, pos=3, col=rep(c("red","green","blue"), times=c(5, 1, 3)))
# Add a legend showing the correspondence between profiles and samples.
legend('topright',  legend=c("M-0182896", "Pi1845A", "Pi1889"), pch=16, col=c('red', 'green', 'blue'), bty='n', cex=.75)
dev.off()

# Perform Principal Component Analysis
pca <- prcomp(t(abundances), scale.=T)
# Calculate the percentage of the variance accounted by principal components 1 and 2
PC1 <- round (100 * (summary(pca)$importance[2,1]), 1)
PC2 <- round (100 * (summary(pca)$importance[2,2]), 1)
# Plot PCA scores for principal component 1 and 2
pdf("PCA_genus.pdf")

# Plot the first two principal components
plot(pca$x[,1], pca$x[,2], pch=16, cex=1.5, cex.axis=0.9, font.lab=2, font.axis=2, xlab=paste("Principal component 1 - ", PC1, "% variance", sep=""), ylab=paste("Principal component 2 - ", PC2, "% variance", sep=""), col=rep(c("red","green","blue"), times=c(5, 1, 3)))
# Add profile name labels, colored using the same color scheme as above.
text(pca$x[,1], pca$x[,2], colnames(abundances), font=2, cex=0.8, pos=3, col=rep(c("red", "green", "blue"), times=c(5, 1, 3)))
# Add a legend showing the correspondence between profiles and samples.
legend('topright',  legend=c("M-0182896", "Pi1845A", "Pi1889"), pch=16, col=c('red', 'green', 'blue'), bty='n', cex=.75)

# Plot PCA loadings and their labels
vectors.x <- (pca$rotation[,1]) * 8
vectors.y <- (pca$rotation[,2]) * 8
points(cbind(vectors.x, vectors.y), col="grey50", type="n")
text(cbind(vectors.x, vectors.y), rownames(cbind(vectors.x, vectors.y)), cex=0.6, font=2, pos=3, col="grey50")
for (v in 1:length(vectors.x)) {
    segments(0,0, vectors.x[v], vectors.y[v], col="grey50", lty=3, lwd=2.5)
}
dev.off()


############################################################
## Part 51:

library(pvclust)
clustering <- pvclust(abundances, method.dist="manhattan", method.hclust="average", nboot=1000)
pdf("Clustering_genus.pdf")
plot(clustering)
dev.off()

clustering


############################################################
## Part 53:

# Import and format class-level abundance data
input2 <- read.csv("Potato_merged_profiles.csv", header=TRUE, row.names=1, sep="\t")
abundances2 <- input2[row.names(input2)[grep("c__[\\w_]*$", row.names(input2), perl=TRUE)],]
row.names(abundances2) <- sapply(strsplit(row.names(abundances2), "c__"), `[`, 2)
data_table <- data.frame(samples=rep(colnames(abundances2), each=dim(abundances2)[1]), taxa=rep(row.names(abundances2), dim(abundances2)[2]), datavect=unlist(abundances2))

library(ggplot2)
library(grid)
# Draw the stacked bar plot
ggplot(data_table, aes(x=samples)) + geom_bar(aes(weight=datavect, fill=taxa), position='fill') + scale_y_continuous("", breaks=NULL) + scale_fill_manual(values=rainbow(dim(abundances2)[1])) + theme(axis.text.x=element_text(angle=90, hjust = 0, color="black"), legend.text=element_text(size = 8)) + theme(legend.key.size=unit(0.6, "lines"))
ggsave("Barplot_class.pdf")

#!/bin/bash
# this is a rough edit of upstreams tests/bwa/run.sh to make
# it somehow working.  It definitely needs more care (FIXME!)
# to make it a real test

set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

echo cd $(dirname $0)

# Errors to ignore during valiation
IGNORE="IGNORE=RECORD_MISSING_READ_GROUP IGNORE=MISSING_READ_GROUP"

ls -d testcases/* |
while read testcase;
do
	echo "Running testcase ${testcase}: $(head -n1 ${testcase}/README)"
	mkdir -p debian
	ln -sf /usr/bin/bwa debian
	readlink debian/bwa |
	while read BWA;
	do
		echo -n "  $BWA "

		rm -rf temp
        folder="runs/$testcase/$(dirname $BWA | xargs basename)"
        rm -rf $folder
        mkdir -p $folder
        ln -s $folder temp

		msg=""
		returncode=-1

		cp ${testcase}/* temp/
		if [ -e "temp/run.sh" ];
		then
			bash "temp/run.sh" "/usr/bin/bwa" && returncode=$? || returncode=$?

			if [ -e "temp/run.log" ];
			then
				msg="$(head -n1 temp/run.log)"
			fi
		elif [ -e "temp/reads1.fasta" ];
		then
			PREFIX=temp/prefix.fasta
			READS1=temp/reads1.fasta
			READS2=temp/reads2.fasta
			RESULTS=temp/results

            command="index"
			if $BWA index ${PREFIX} 2> ${PREFIX}.log;
			then
                command="aln #1"
				if $BWA aln ${PREFIX} ${READS1} > ${READS1}.fai 2> ${READS1}.log;
				then
                    command="aln #2"
					if $BWA aln ${PREFIX} ${READS2} > ${READS2}.fai 2> ${READS2}.log;
					then
                        command="sampe"
						if $BWA sampe ${PREFIX} ${READS1}.fai ${READS2}.fai ${READS1} ${READS2} 2> ${RESULTS}.log | \
							paleomix cleanup --paired --fasta ${PREFIX} --temp-prefix temp/cleanup 2> ${RESULTS}.cleanup.log >  ${RESULTS}.bam;
						then
							java -jar "ValidateSamFile.jar" ${IGNORE} I=${RESULTS}.bam &> ${RESULTS}.bam.validated \
								&& returncode=$? || returncode=$?

							if [ -e "${RESULTS}.bam.validated" ];
							then
								msg="$((grep ERROR ${RESULTS}.bam.validated || true) | head -n1)"
							fi
						fi
					fi
				fi
			fi
		fi

		if test $returncode -eq 0;
		then
			echo -e "\033[32m[OK]\033[0m"
		elif test $returncode -eq -1;
		then
			echo -e "\033[31m[TEST ERROR]: $command\033[0m"
		else
			echo -e "\033[33m[FAILED]\033[0m: $msg"
		fi
	done
done

rm -rf temp

#!/bin/bash
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

echo cd $(dirname $0)

if [ ! -e "ValidateSamFile.jar" ];
then
	echo "Please place 'ValidateSamFile.jar' in the current folder."
	exit 1
fi

# Fetch and build relevant versions of BWA
function build_bwa ()
{
	local version=$1
	local bwaarch=bwa-${version}.tar.bz2
	local bwadir=bwa-${version}

	cd ./builds
	if [ ! -e "${bwadir}/bwa" ];
	then
		echo "Building BWA v${version}"

		if [ ! -e "${bwadir}" ];
		then
			if [ ! -e "${bwaarch}" ];
			then
				wget "http://sourceforge.net/projects/bio-bwa/files/bwa-${version}.tar.bz2/download" \
					-O ${bwaarch}
			fi

			tar xvjf bwa-${version}.tar.bz2
		fi

		nice -19 make -C bwa-${version}
	fi

	cd ..
}

mkdir -p builds

build_bwa 0.7.12
build_bwa 0.7.11
build_bwa 0.7.10
build_bwa 0.7.9a
build_bwa 0.7.8
build_bwa 0.7.7
build_bwa 0.7.6a # This version is broken (no aln command!)
build_bwa 0.7.5a
build_bwa 0.7.4
build_bwa 0.7.3a
build_bwa 0.7.2
build_bwa 0.7.1
# build_bwa 0.7.0 # Broken, does not compile
#build_bwa 0.6.2
#build_bwa 0.6.1
#build_bwa 0.5.9
#build_bwa 0.6.0
#build_bwa 0.5.10
#build_bwa 0.5.9rc1 # Oldest acceptable version


cd builds
if [ ! -e "bwa-git" ];
then
	git clone "https://github.com/lh3/bwa.git" "bwa-git"
fi

cd bwa-git
git pull
make
cd ../../


# Errors to ignore during valiation
IGNORE="IGNORE=RECORD_MISSING_READ_GROUP IGNORE=MISSING_READ_GROUP"

ls -d testcases/* |
while read testcase;
do
	echo "Running testcase ${testcase}: $(head -n1 ${testcase}/README)"
	ls builds/*/bwa |
	while read BWA;
	do
		echo -n "  $BWA "

		rm -rf temp
        folder="runs/$testcase/$(dirname $BWA | xargs basename)"
        rm -rf $folder
        mkdir -p $folder
        ln -s $folder temp

		msg=""
		returncode=-1

		cp ${testcase}/* temp/
		if [ -e "temp/run.sh" ];
		then
			bash "temp/run.sh" "$(pwd)/$BWA" && returncode=$? || returncode=$?

			if [ -e "temp/run.log" ];
			then
				msg="$(head -n1 temp/run.log)"
			fi
		elif [ -e "temp/reads1.fasta" ];
		then
			PREFIX=temp/prefix.fasta
			READS1=temp/reads1.fasta
			READS2=temp/reads2.fasta
			RESULTS=temp/results

            command="index"
			if $BWA index ${PREFIX} 2> ${PREFIX}.log;
			then
                command="aln #1"
				if $BWA aln ${PREFIX} ${READS1} > ${READS1}.fai 2> ${READS1}.log;
				then
                    command="aln #2"
					if $BWA aln ${PREFIX} ${READS2} > ${READS2}.fai 2> ${READS2}.log;
					then
                        command="sampe"
						if $BWA sampe ${PREFIX} ${READS1}.fai ${READS2}.fai ${READS1} ${READS2} 2> ${RESULTS}.log | \
							paleomix cleanup --paired --fasta ${PREFIX} --temp-prefix temp/cleanup 2> ${RESULTS}.cleanup.log >  ${RESULTS}.bam;
						then
							java -jar "ValidateSamFile.jar" ${IGNORE} I=${RESULTS}.bam &> ${RESULTS}.bam.validated \
								&& returncode=$? || returncode=$?

							if [ -e "${RESULTS}.bam.validated" ];
							then
								msg="$((grep ERROR ${RESULTS}.bam.validated || true) | head -n1)"
							fi
						fi
					fi
				fi
			fi
		fi

		if test $returncode -eq 0;
		then
			echo -e "\033[32m[OK]\033[0m"
		elif test $returncode -eq -1;
		then
			echo -e "\033[31m[TEST ERROR]: $command\033[0m"
		else
			echo -e "\033[33m[FAILED]\033[0m: $msg"
		fi
	done
done

rm -rf temp

#!/bin/bash

set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

cd $(dirname $0)

if [ ! -e "Pi_nucl.fasta" ];
then
    echo "Fetching P. infestans T30-4 nuclear genome"
    echo "  See http://protists.ensembl.org/Phytophthora_infestans/Info/Index"
    curl "ftp://ftp.ensemblgenomes.org/pub/protists/release-20/fasta/phytophthora_infestans/dna/Phytophthora_infestans.ASM14294v1.20.dna.toplevel.fa.gz" \
	-C - -o "Pi_nucl.fasta.gz"
    gunzip "Pi_nucl.fasta.gz"
else
    echo "Pi_mito.fasta already fetched; skipping ..."
fi

echo
if [ ! -e "Pi_mito.fasta" ];
then
    echo "Fetching P. infestans mitochondrial genome"
    echo "  See http://www.ncbi.nlm.nih.gov/nuccore/AY894835.1"
    curl "http://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=nuccore&id=AY894835.1&rettype=fasta&retmode=text" \
	-C - -o "Pi_mito.fasta"
else
    echo "Pi_mito.fasta already fetched; skipping ..."
fi

#!/bin/bash

set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

if [ ! -e "paleomix" ];
then
    cd ..
fi

find paleomix -name '*.py' -type f \
    | sed -e's#\.py##' -e's#/#.#g' -e's#^#import #' \
    | grep -v "__init__\|yaml\|resources" \
    > tests/all_modules.py

#!/bin/bash
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

cd $(dirname $0)

BWA=$1
PREFIX=prefix.fasta

rm -f ${PREFIX}.*

$BWA index ${PREFIX} 2> run.log
$BWA aln ${PREFIX} reads.fasta > reads.fasta.fai 2> run.log

$BWA samse ${PREFIX} reads.fasta.fai reads.fasta 2> run.log > results.sam

set +o pipefail
samtools view -S results.sam 2>&1|grep error > run.log && exit 1 || exit 0

#!/bin/bash
#
# Copyright (c) 2013 Mikkel Schubert <MikkelSch@gmail.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

if [ $# -lt 2 ];
then
    echo "Usage: $0 <output-prefix> <input_1.bz2> [<input_2.bz2>, ...]"
    exit 1
fi

OUTPUT_PREFIX=$1
# Remove the prefix parameter from the list of parameters
shift 1

JAR_ROOT=~/install/jar_root
METAPHLAN_ROOT=~/install/metaphlan
BOWTIE_PREFIX=${METAPHLAN_ROOT}/bowtie2db/mpa

OUTPUT_SAM=${OUTPUT_PREFIX}.bowtie2.out.sam
OUTPUT_SORTED_BAM=${OUTPUT_PREFIX}.sorted.bam
OUTPUT_RMDUP_BAM=${OUTPUT_PREFIX}.noduplicates.bam
OUTPUT_METAPHLAN_INPUT=${OUTPUT_PREFIX}.noduplicates
OUTPUT_METAPHLAN=${OUTPUT_PREFIX}.txt

if [ ! -e "${JAR_ROOT}/SortSam.jar" ];
then
    echo "Required JAR file is missing; please install:"
    echo "  - ${JAR_ROOT}/SortSam.jar"
    exit 1
elif [ ! -e "${METAPHLAN_ROOT}/metaphlan.py" ];
then
    echo "MetaPhlAn does not appear to be installed; please install at:"
    echo "  - ${METAPHLAN_ROOT}/metaphlan.py"
    exit 1
fi

for executable in bzcat bowtie2 java bam_rmdup_collapsed samtools;
do
    if ! which ${executable} > /dev/null;
    then
	echo "Required executable is missing ('${executable}'); please install."
	exit 1
    fi
done


echo
echo "Generating profile from $# files, saving to ${OUTPUT_METAPHLAN}"

if [ ! -e "${OUTPUT_METAPHLAN}" ];
then
    if [ ! -e "${OUTPUT_METAPHLAN_INPUT}" ];
    then
	if [ ! -e "${OUTPUT_RMDUP_BAM}" ];
	then
	    if [ ! -e "${OUTPUT_SORTED_BAM}" ];
	    then
		if [ ! -e "${OUTPUT_SAM}" ];
		then
		    bzcat $@ | bowtie2 -x "${BOWTIE_PREFIX}" -U - -S "${OUTPUT_SAM}.tmp" --no-unal --quiet
		    mv "${OUTPUT_SAM}.tmp" "${OUTPUT_SAM}"
		fi

		java -Xmx4g -jar ${JAR_ROOT}/SortSam.jar SO=coordinate VERBOSITY=WARNING QUIET=TRUE \
		    "I=${OUTPUT_SAM}" "O=${OUTPUT_SORTED_BAM}.tmp"
		mv "${OUTPUT_SORTED_BAM}.tmp" "${OUTPUT_SORTED_BAM}"
	    fi

	    bam_rmdup_collapsed --remove-duplicates < "${OUTPUT_SORTED_BAM}" > "${OUTPUT_RMDUP_BAM}.tmp"
	    mv "${OUTPUT_RMDUP_BAM}.tmp" "${OUTPUT_RMDUP_BAM}"
	fi

	samtools view ${OUTPUT_RMDUP_BAM} | awk '{print $1 "\t" $3}' > "${OUTPUT_METAPHLAN_INPUT}.tmp";
	mv "${OUTPUT_METAPHLAN_INPUT}.tmp" "${OUTPUT_METAPHLAN_INPUT}"
    fi

    ${METAPHLAN_ROOT}/metaphlan.py "${OUTPUT_METAPHLAN_INPUT}" > "${OUTPUT_METAPHLAN}.tmp"
    mv "${OUTPUT_METAPHLAN}.tmp" "${OUTPUT_METAPHLAN}"
fi

echo "Done: Profile written to ${OUTPUT_METAPHLAN}"

#!/bin/bash
#
# Copyright (c) 2013 Mikkel Schubert <MikkelSch@gmail.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

rm -rvf alignment/reads
mkdir -p alignment/reads
for PREFIX in `ls alignment/prefixes/*.fasta | grep -v rCRS`;
do
    SP_SEED=${RANDOM}
    NAME=$(echo ${PREFIX} | sed -e's#alignment/prefixes/##' -e's#\..*##')
    mkdir -p alignment/reads/${NAME/*\//}/

    ./synthesize_reads.py ${PREFIX} alignment/reads/${NAME}/ \
		--specimen-seed=${SP_SEED} \
		--lanes-reads-mu=50000 \
		--lanes-reads-sigma=500 \
		--lanes-reads-per-file=10000 \
		--reads-len=50 \
		--lanes=1
done

# These links would not survive the package installation, so setup here
ln -sf ../../alignment/prefixes/ phylogeny/data/prefixes
ln -sf ../../alignment phylogeny/data/samples

# Create link to reference sequence
mkdir -p phylogeny/data/refseqs
ln -sf ../../../alignment/prefixes/rCRS.fasta phylogeny/data/refseqs/rCRS.rCRS.fasta

#!/bin/bash
#
# Copyright (c) 2013 Mikkel Schubert <MikkelSch@gmail.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

SP_SEED=${RANDOM}

rm -rv data
mkdir -p data
for barcode in ACGATA GCTCTG TGCTCA;
do
    python $(dirname $0)/synthesize_reads.py prefixes/rCRS.fasta data/ \
	--library-barcode=${barcode} \
	--specimen-seed=${SP_SEED} \
	--lanes-reads-mu=2500 \
	--lanes-reads-sigma=500 \
	--lanes-reads-per-file=1000 \
	--lanes=2 \
	--damage
done

rm -v data/GCTCTG_L*R2*.gz
rm -v data/TGCTCA_L1_R2*.gz

paleomix bam run $(dirname $0)/setup_bam_pipeline_example.makefile.yaml --destination .

mkdir -p data/ACGATA_L2/
mv ExampleProject/reads/Synthetic_Sample_1/ACGATA/Lane_2/reads.singleton.truncated.gz data/ACGATA_L2/reads.singleton.truncated.gz
mv ExampleProject/reads/Synthetic_Sample_1/ACGATA/Lane_2/reads.collapsed.gz data/ACGATA_L2/reads.collapsed.gz
mv ExampleProject/reads/Synthetic_Sample_1/ACGATA/Lane_2/reads.collapsed.truncated.gz data/ACGATA_L2/reads.collapsed.truncated.gz

mv ExampleProject/rCRS/Synthetic_Sample_1/GCTCTG/Lane_2/single.minQ0.bam data/GCTCTG_L2.bam

rm -v data/ACGATA_L2_R*.fastq.gz
rm -v data/GCTCTG_L2_R1_*.fastq.gz
rm -rv ExampleProject

#!/bin/bash
#
# Copyright (c) 2013 Mikkel Schubert <MSchubert@snm.ku.dk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

{
## Pi1845A
echo Pi1845A.id.CGCTAT ../alignment/Pi1845A/reads/Pi1845A/Pi1845A_id_CGCTAT/*/reads.collapsed.bz2

## Pi1889
echo Pi1889.id.CTTGTA ../alignment/Pi1889/reads/Pi1889/Pi1889_id_CTTGTA/*/reads.collapsed.bz2
echo Pi1889.id.TAGCTT ../alignment/Pi1889/reads/Pi1889/Pi1889_id_TAGCTT/*/reads.collapsed.bz2
echo Pi1889.id.GGCTAC ../alignment/Pi1889/reads/Pi1889/Pi1889_id_GGCTAC/*/reads.collapsed.bz2

## M-0182896
echo M.0182896_UDG    ../alignment/M-0182896/reads/M-0182896/M-0182896_UDG/*/reads.collapsed.bz2
echo M.0182896_UDGa   ../alignment/M-0182896/reads/M-0182896/M-0182896_UDGa/*/reads.collapsed.bz2
echo M.0182896_UDGb   ../alignment/M-0182896/reads/M-0182896/M-0182896_UDGb/*/reads.collapsed.bz2
echo M.0182896_UDGc   ../alignment/M-0182896/reads/M-0182896/M-0182896_UDGc/*/reads.collapsed.bz2
echo M.0182896_NO_UDG ../alignment/M-0182896/reads/M-0182896/M-0182896_NO_UDG/*/reads.collapsed.bz2
} | xargs -P 16 -L1 ./build_profile.sh

#!/bin/bash

set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

cd $(dirname $0)

for ENA in `ls */000_ENA | sort`;
do
    SAMPLE=$(dirname ${ENA})
    echo "Fetching FASTQ reads for sample '${SAMPLE}' ..."

    tail -n +2 ${ENA} | cut -f10 | tr ";" "\n" |
    while read URL;
    do
	FNAME=$(echo $URL | sed -e's#.*/##')
	echo "  - $FNAME"

	if [ ! -e "${SAMPLE}/${FNAME}.DONE" ];
	then
	    PREFIX=${FNAME/.fastq.gz/}
	    # Split into chunks of 10M reads
	    curl "${URL}" | gunzip | split -l 40000000 -a 3 - "${SAMPLE}/${PREFIX}_"

	    ls ${SAMPLE}/${PREFIX}_* |
	    while read FNAME;
	    do
		mv ${FNAME} ${FNAME}.fastq
	    done

	    ls ${SAMPLE}/${PREFIX}_*.fastq | xargs -n 1 -P 8 gzip --verbose

	    touch "${SAMPLE}/${FNAME}.DONE";
	fi
    done
done

#!/bin/bash
set -o nounset # Fail on unset variables
set -o errexit # Fail on uncaught non-zero returncodes
set -o pipefail # Fail is a command in a chain of pipes fails

cd $(dirname $0)

BWA=$1
PREFIX=prefix.fasta

rm -f ${PREFIX}.*

$BWA index ${PREFIX} 2> ${PREFIX}.log
$BWA aln ${PREFIX} reads1.fasta > reads1.fasta.fai 2> reads1.fasta.log
$BWA aln ${PREFIX} reads2.fasta > reads2.fasta.fai 2> reads2.fasta.log

set +o pipefail # Fail is a command in a chain of pipes fails
$BWA sampe ${PREFIX} reads1.fasta.fai reads2.fasta.fai reads1.fasta reads2.fasta 2>&1 | grep "Assertion" > run.log && exit 13 || exit 0

#../../check_sam.py --flags-unset 4 --position -1 results.sam
